<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= title %></h2>
  </div>
  <div class="card-section">
  <h2 class="new-meeting-title">Sobre o Evento</h2>
    <div class="row column hashtags__container">
      <%= form.translated :text_field, :title, autofocus: true, class: "js-hashtags", hashtaggable: true, required: true %>
    </div>
    <div class="row column hashtags__container">
      <%= form.translated :editor, :description, hashtaggable: true, data: { required: true }, required: true %>
    </div>
    <span class="br-divider"></span>
    <h2 class="new-meeting-title">Formato do Evento</h2>
    <div class="row column">
      <%= form.select :type_of_meeting,
        @form.type_of_meeting_select,
        { include_blank: t(".select_a_meeting_type") },
        { multiple: false } %>
    </div>
    <div class="field">
      <%= form.select :associated_state,
                      @form.meeting_state_select,
                      { include_blank: t(".select_a_meeting_associated_state") },
                      { multiple: false } %>
    </div>
    <div class="field" data-meeting-type="in_person">
      <%= form.geocoding_field :address %>
      <p class="help-text"><%= t(".address_help") %></p>
    </div>
    <div class="field" data-meeting-type="in_person">
      <%= form.translated :text_area, :location %>
      <p class="help-text"><%= t(".location_help") %></p>
    </div>
    <div class="row column">
      <%= form.translated :text_area, :location_hints %>
      <p class="help-text"><%= t(".location_hints_help") %></p>
    </div>
    <div class="field" data-meeting-type="online">
      <%= form.text_field :online_meeting_url %>
      <p class="help-text"><%= t(".online_meeting_url_help") %></p>
    </div>
    <div class="iframe-fields">
      <div class="row column field iframe-fields--embed-type" id="meeting_iframe_embed_type" data-meeting-type="online">
        <%= form.select :iframe_embed_type,
          @form.iframe_embed_type_select,
          { multiple: false } %>
        <p class="help-text"><%= t(".show_embedded_iframe_help", domains: Decidim::Meetings.embeddable_services&.join(" ")) %></p>
      </div>
      <div class="row column field iframe-fields--access-level" data-meeting-type="online-access-level">
        <%= form.select :iframe_access_level,
          @form.iframe_access_level_select,
          { include_blank: t(".select_an_iframe_access_level") },
          { multiple: false } %>
      </div>
    </div>
    <span class="br-divider"></span>
    <h2 class="new-meeting-title">Duração do Evento</h2>
    <div class="row">
      <div class="columns xlarge-6">
        <%= form.datetime_field :start_time, id:"meeting_start_time" %>
        <%= form.check_box :to_define, label: t(".to_define"), id: "to_define" %>
      </div>
      <div class="columns xlarge-6">
        <%= form.datetime_field :end_time, id:"meeting_end_time" %>
        <%= form.check_box :to_define_end_time, label: t(".to_define"), id: "to_define_end_time" %>
      </div>
    </div>
    <div class="row column">
    </div>
    <div class="row">
      <% if current_component.has_subscopes? %>
        <div class="columns xlarge-6">
          <%= scopes_picker_field form, :decidim_scope_id, root: current_component.scope %>
        </div>
      <% end %>
      <div class="columns xlarge-6">
        <%= form.categories_select :decidim_category_id, current_participatory_space.categories, include_blank: "", disable_parents: false %>
      </div>
    </div>
    <span class="br-divider"></span>
    <h2 class="new-meeting-title">Inscrição do Evento</h2>
    <div class="row column">
      <%= form.select :registration_type,
        @form.registration_type_select,
        { include_blank: t(".select_a_registration_type") },
        { multiple: false } %>
    </div>
    <div class="field" id="meeting_registration_url">
      <%= form.text_field :registration_url %>
      <p class="help-text"><%= t(".registration_url_help") %></p>
      <div class="callout alert">
        <%= t(".disclaimer", organization: current_component.organization.name) %>
      </div>
    </div>
    <div class="row column" id="private_meeting">
      <%= form.check_box :private_meeting %>
    </div>
    <div class="row column" id="transparent">
      <%= form.check_box :transparent %>
    </div>
    <%= render partial: "decidim/comments/admin/shared/availability_fields", locals: { form: form } %>
  </div>
</div>
<% if false %>
  <%= render "decidim/meetings/admin/meetings/services", form: form, id: tabs_id_for_service(blank_service) %>
<% end %>
<%= javascript_pack_tag "decidim_meetings_admin" %>
<style>
.br-divider{
  --divider-size: var(--surface-width-sm);
  border-color: darkgray;
  border-style: solid;
  border-width: 0;
  border-top-width: var(--divider-size);
  display: block;
}
</style>
<script>
  document.addEventListener("DOMContentLoaded", function() {
    const form = document.querySelector(".meetings_form");
    const submitButton = form.querySelector("button[type='submit']");
    const toDefine = document.getElementById('to_define');
    const toDefineEndTime = document.getElementById('to_define_end_time');
    const startTimeInput = document.getElementById('meeting_start_time');
    const endTimeInput = document.getElementById('meeting_end_time');
    
    const editorLabel = document.querySelector("label[for='meeting_description_pt__BR']");
    const qlEditor = document.querySelector(".editor-container");   
    const editorContent = document.getElementById('meeting_description_pt__BR');  

    const typeOfMeetingSelect = document.querySelector("select[name='meeting[type_of_meeting]']");

    const addressField = document.querySelector("input[name='meeting[address]']");
    const addressLabel = document.querySelector("label[for='meeting_address']");
    const locationField = document.querySelector("textarea[name='meeting[location_pt__BR]']");
    const locationLabel = document.querySelector("label[for='meeting_location_pt__BR']");
    const urlField = document.querySelector("input[name='meeting[online_meeting_url]']");
    const urlLabel = document.querySelector("label[for='meeting_online_meeting_url']");
    const addressFieldContainer = document.querySelector("[data-meeting-type='in_person']"); 
    const locationFieldContainer = document.querySelector("[data-meeting-type='in_person']:nth-child(2)"); 
    const urlFieldContainer = document.querySelector("[data-meeting-type='online']");

    const iframeEmbedTypeField = document.querySelector("select[name='meeting[iframe_embed_type]']");
    const iframeEmbedTypeLabel = document.querySelector("label[for='meeting_iframe_embed_type']");

    if (submitButton) {
      submitButton.addEventListener("click", function(event) {
        const invalidInput = form.querySelector(".is-invalid-input");
        if (invalidInput) {
          invalidInput.scrollIntoView({ behavior: "smooth", block: "center" });
          }
      })
    }


    const toggleRequiredFields = () => {
      const selectedMeetingType = typeOfMeetingSelect.value;

      if (selectedMeetingType === "in_person" || selectedMeetingType === "hybrid") {
        urlField.removeAttribute("required");
        iframeEmbedTypeField.removeAttribute("required");
        urlLabel.firstChild.textContent = urlLabel.firstChild.textContent.replace(' *', '');
        iframeEmbedTypeLabel.firstChild.textContent = iframeEmbedTypeLabel.firstChild.textContent.replace(' *', '');
        addressField.setAttribute("required", true);
        if (!addressLabel.firstChild.textContent.includes(' *')) {
          addressLabel.firstChild.textContent += ' *';
        }
        locationField.setAttribute("required", true);
        if (!locationLabel.firstChild.textContent.includes(' *')) {
          locationLabel.firstChild.textContent += ' *';
        }
      }
      else {
        addressField.removeAttribute("required");
        addressLabel.firstChild.textContent = addressLabel.firstChild.textContent.replace(' *', '');
        locationField.removeAttribute("required");
        locationLabel.firstChild.textContent = locationLabel.firstChild.textContent.replace(' *', '');
        
        if (selectedMeetingType === "online") {
          urlField.setAttribute("required", true);
          iframeEmbedTypeField.setAttribute("required", true);
          if (!urlLabel.firstChild.textContent.includes(' *')){
            urlLabel.firstChild.textContent += ' *';
          }
          if (!iframeEmbedTypeLabel.firstChild.textContent.includes(' *')){
            iframeEmbedTypeLabel.firstChild.textContent += ' *';
          }  
        }
      }
    }

    typeOfMeetingSelect.addEventListener('change', toggleRequiredFields);

    if (editorLabel) {
      editorLabel.innerHTML += ' *'; 
    }

    let editorTouched = false;  
  
    const validateEditor = () => {
      const editorValue = editorContent.value.trim();  
      
      if (!editorValue || editorValue === "<p><br></p>") {  
        if (editorTouched) {  
          qlEditor.classList.add("is-invalid-input");  
          editorLabel.classList.add("is-invalid-label");
        }
      } else {
        qlEditor.classList.remove("is-invalid-input");  
        editorLabel.classList.remove("is-invalid-label");
      }
    };

    if (qlEditor) {
      qlEditor.addEventListener('focus', () => {
        editorTouched = true;
      }, true);  

      qlEditor.addEventListener('blur', validateEditor, true);  
      
      qlEditor.addEventListener('input', validateEditor);
    }

    const updateStartTime = () => {
      if (toDefine && toDefine.checked) {
        startTimeInput.disabled = true;
      } else {
        startTimeInput.disabled = false;
      }
    };

    const updateEndTime = () => {
      if (toDefineEndTime && toDefineEndTime.checked) {
        endTimeInput.disabled = true;
      } else {
        endTimeInput.disabled = false;
      }
    };

    const updateCheckbox = () => {
      if(startTimeInput && startTimeInput.value === "" ){
        toDefine.checked = true;
      }
      if(endTimeInput && endTimeInput.value === ""){
        toDefineEndTime.checked = true;
      }
    };

    updateCheckbox();
    updateStartTime();
    updateEndTime();
    validateEditor();

    toDefine.addEventListener('change', updateStartTime);
    toDefineEndTime.addEventListener('change', updateEndTime);
  });
</script>